package weaver.formmode.recruit.modeexpand.departmentscreening;

import com.engine.recruit.conn.ApplicantCommonInfo;
import com.engine.recruit.constant.RecruitConstant;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.formmode.customjavacode.AbstractModeExpandJavaCodeNew;
import weaver.formmode.recruit.modeexpand.util.RecruitModeUtil;
import weaver.formmode.setup.ModeRightInfo;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.soa.workflow.request.*;

import java.util.*;

/**
 * <p>聚才林招聘</p>
 * 批量发起部门筛选，转部门筛选反馈数据
 *
 * @author:dxfeng
 * @createTime: 2023/09/18
 * @version: 1.0
 */
public class BatchAddDeptScreeningModeExpand extends AbstractModeExpandJavaCodeNew {
    /**
     * JCL_部门筛选反馈(uf_jcl_bmsxfk)
     */
    private static final String MODE_TABLE_NAME = "uf_jcl_bmsxfk";

    @Override
    public Map<String, String> doModeExpand(Map<String, Object> param) {
        Map<String, String> result = new HashMap<>();
        try {
            RequestInfo requestInfo = (RequestInfo) param.get("RequestInfo");
            if (requestInfo != null) {
                RecordSet rs = new RecordSet();
                int formModeId = ApplicantCommonInfo.getModeIdByTableName(MODE_TABLE_NAME);
                MainTableInfo mainTableInfo = requestInfo.getMainTableInfo();
                Property[] properties = mainTableInfo.getProperty();
                Map<String, Object> mainDataMap = new HashMap<>();
                for (Property property : properties) {
                    mainDataMap.put(property.getName(), property.getValue());
                }
                User user = (User) param.get("user");

                // 部门筛选ID
                mainDataMap.put("bmsxid", requestInfo.getRequestid());
                // 状态
                mainDataMap.put("zt", "0");
                // 填充建模数据基本信息
                mainDataMap.put("formmodeid", formModeId);
                mainDataMap.put("modedatacreater", user.getUID());
                String dateTime = DateUtil.getFullDate();
                String[] split = dateTime.split(" ");
                mainDataMap.put("modedatacreatedate", split[0]);
                mainDataMap.put("modedatacreatetime", split[1]);
                mainDataMap.put("modedatamodifier", null);
                mainDataMap.put("modedatamodifydatetime", null);
                mainDataMap.put("modedatacreatertype", "0");

                List<Map<String, Object>> detailMapList = new ArrayList<>();
                DetailTableInfo detailTableInfo = requestInfo.getDetailTableInfo();
                DetailTable detailTable = detailTableInfo.getDetailTable(0);
                Row[] rows = detailTable.getRow();
                for (Row row : rows) {
                    Map<String, Object> detailDataMap = new HashMap<>(mainDataMap);
                    Cell[] cells = row.getCell();
                    for (Cell cell : cells) {
                        detailDataMap.put(cell.getName(), cell.getValue());
                    }
                    detailMapList.add(detailDataMap);
                }

                StringBuilder msgBuilder = new StringBuilder();
                msgBuilder.append(user.getLastname()).append("给你发来简历进行筛选，请查看。<br/>");
                for (Map<String, Object> detailDataMap : detailMapList) {
                    List<List<Object>> paramList = new ArrayList<>();
                    buildParamList(detailDataMap, paramList);
                    if (CollectionUtils.isNotEmpty(paramList)) {
                        String insertSql = "insert into " + MODE_TABLE_NAME + " (modeuuid, modedatacreatertype, formmodeid, modedatacreater, modedatacreatedate, modedatacreatetime, modedatamodifier, modedatamodifydatetime, bmsxid, ypz, ypzw, tdsj, zt, pcid, fkr) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
                        for (List<Object> objects : paramList) {
                            String uuid = UUID.randomUUID().toString();
                            objects.add(0, uuid);
                            rs.executeUpdate(insertSql, objects);
                            refreshRight(user, rs, uuid, formModeId);
                        }
                    }
                    String applicantName = ApplicantCommonInfo.getApplicantName(Util.null2String(detailDataMap.get("ypz")));
                    String applicantPosition = ApplicantCommonInfo.getApplicantPosition(Util.null2String(detailDataMap.get("ypzw")));
                    msgBuilder.append("【应聘者：").append(applicantName).append("，应聘职位：").append(applicantPosition).append("】").append("<br/>");
                }

                // 发送待办消息
                String messageType = RecruitConstant.SCREENING_MESSAGE_TYPE;
                String messageTitle = RecruitConstant.SCREENING_MESSAGE_TITLE;
                String linkUrl = RecruitConstant.SCREENING_MESSAGE_URL;
                String fkr = Util.null2String(mainDataMap.get("fkr"));
                Set<String> userIdSet = new HashSet<>(Arrays.asList(fkr.split(",")));
                RecruitModeUtil.messagePush(messageType, messageTitle, msgBuilder.toString(), userIdSet, user.getUID(), linkUrl, "");
            }
        } catch (Exception e) {
            new BaseBean().writeLog(e);
            result.put("errmsg", "自定义出错信息");
            result.put("flag", "false");
        }
        return result;
    }

    /**
     * 构建批量插入数据集合
     *
     * @param map       表单参数
     * @param paramList 待插入数据集合
     */
    private void buildParamList(Map<String, Object> map, List<List<Object>> paramList) {
        List<Object> param = new ArrayList<>();
        // 填充建模表相关字段
        param.add(map.get("modedatacreatertype"));
        param.add(map.get("formmodeid"));
        param.add(map.get("modedatacreater"));
        param.add(map.get("modedatacreatedate"));
        param.add(map.get("modedatacreatetime"));
        param.add(map.get("modedatamodifier"));
        param.add(map.get("modedatamodifydatetime"));

        //部门筛选ID
        param.add(map.get("bmsxid"));
        // 应聘者
        param.add(map.get("ypz"));
        // 应聘职位
        param.add(map.get("ypzw"));
        // 投递时间
        param.add(map.get("tdsj"));
        // 状态
        param.add(map.get("zt"));
        // 批次ID
        param.add(map.get("pcid"));
        // 反馈人
        String fkr = Util.null2String(map.get("fkr"));
        if (StringUtils.isNotBlank(fkr)) {
            String[] fkrArray = fkr.split(",");
            for (String fkrId : fkrArray) {
                ArrayList<Object> objects = new ArrayList<>(param);
                objects.add(fkrId);
                paramList.add(objects);
            }
        }
    }

    /**
     * 权限重构
     *
     * @param rs         RecordSet
     * @param uuid       UUID
     * @param formModeId 建模ID
     */
    private void refreshRight(User user, RecordSet rs, String uuid, int formModeId) {
        rs.executeQuery("select id from " + MODE_TABLE_NAME + " where modeuuid='" + uuid + "'");
        if (rs.next()) {
            //建模数据的id
            int bid = Util.getIntValue(rs.getString("id"));
            ModeRightInfo modeRightInfo = new ModeRightInfo();
            modeRightInfo.setNewRight(true);
            //新建的时候添加共享
            modeRightInfo.editModeDataShare(user.getUID(), formModeId, bid);
        }
    }
}
